package org.colcon.web.client;

import org.colcon.burocrat.api.client.IClient;
import org.colcon.burocrat.api.client.IItemPageImpl;
import org.colcon.burocrat.api.model.IItem;
import org.colcon.burocrat.client.item.ItemPage;
import org.colcon.web.client.item.AgentPage;
import org.colcon.web.client.item.GroupPage;
import org.colcon.web.client.item.LawPage;
import org.colcon.web.client.item.NewsPage;
import org.colcon.web.client.item.PowerPage;
import org.colcon.web.client.item.TitlePage;
import org.colcon.web.client.item.TopicPage;
import org.colcon.web.client.item.UserPage;
import org.colcon.web.client.item.VotePage;

public enum AppItemPageImpl implements IItemPageImpl
{
	NEWS
	{
		public ItemPage buildItemPage(IClient client, IItem item)
		{
			return new NewsPage(client, item);
		}

	},
	POWER
	{
		public ItemPage buildItemPage(IClient client, IItem item)
		{
			return new PowerPage(client, item);
		}

	},
	AGENT
	{
		public ItemPage buildItemPage(IClient client, IItem item)
		{
			return new AgentPage(client, item);
		}

	},
	LAW
	{
		public ItemPage buildItemPage(IClient client, IItem item)
		{
			return new LawPage(client, item);
		}
		
	},
	TITLE
	{
		public ItemPage buildItemPage(IClient client, IItem item)
		{
			return new TitlePage(client, item);
		}

	},
	VOTE
	{
		public ItemPage buildItemPage(IClient client, IItem item)
		{
			return new VotePage(client, item);
		}

	},
	TOPIC
	{
		public ItemPage buildItemPage(IClient client, IItem item)
		{
			return new TopicPage(client, item);
		}

	},
	USER
	{
		public ItemPage buildItemPage(IClient client, IItem item)
		{
			return new UserPage(client, item);
		}

	},
	GROUP
	{
		public ItemPage buildItemPage(IClient client, IItem item)
		{
			return new GroupPage(client, item);
		}

	};

	public static IItemPageImpl[] getValues()
	{
		return (IItemPageImpl[]) values();
	}
}
