package org.colcon.web.client;

import org.colcon.burocrat.api.client.IClient;
import org.colcon.burocrat.api.utils.ArrayUtil;
import org.colcon.burocrat.client.BurocratService;
import org.colcon.burocrat.client.BurocratServiceAsync;
import org.colcon.burocrat.client.Client;
import org.colcon.burocrat.client.PageImpl;
import org.colcon.burocrat.client.ItemPageImpl;
import org.colcon.burocrat.client.FieldTypeImpl;
import org.colcon.burocrat.model.Model;
import org.colcon.web.model.AppModel;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.ui.RootPanel;

/**
 * Entry point classes define <code>onModuleLoad()</code>.
 */
public class Collective_Congress implements EntryPoint
{
	/**
	 * Create a remote service proxy to talk to the server-side service implementation.
	 */
	private final BurocratServiceAsync service = GWT.create(BurocratService.class);
	
	/**
	 * Create an MRCWS client that spans the gap between the browser GUI and the RPC service. 
	 */
	private final IClient client = new Client
	(
		"Collective Congress", 
		
		ArrayUtil.append(PageImpl.getValues(), AppPageImpl.getValues()), 
		ArrayUtil.append(ItemPageImpl.getValues(), AppItemPageImpl.getValues()), 
		FieldTypeImpl.values(),
		
		new AppWidgets(),
		RootPanel.get(), 
		service
	);

	/**
	 * This is the entry point method.
	 */
	public void onModuleLoad() 
	{
		Model.instance = AppModel.instance;
	
		client.refresh();
	}	
}
