/**
 * 
 */
package org.colcon.web.client.item;

import java.util.Date;

import org.colcon.burocrat.api.client.IClient;
import org.colcon.burocrat.api.model.IItem;
import org.colcon.burocrat.client.item.ItemPage;
import org.colcon.burocrat.client.list.NewsList;
import org.colcon.burocrat.client.utils.ImageUtil;
import org.colcon.burocrat.client.utils.TimeUtil;
import org.colcon.burocrat.model.Arg;
import org.colcon.web.client.AppWidgets;
import org.colcon.web.client.ColConCSS;

import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HasVerticalAlignment;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;

/**
 * @author Jesse Freitas
 *
 */
public class UserPage extends ItemPage
{

	/**
	 * @param client
	 * @param item
	 */
	public UserPage(IClient client, IItem item)
	{
		super(client, item);
	}
	public Widget buildHeader(){
		HTML header = new HTML();
		header.setHeight("20px");
		return header;
	}
	public Widget buildPage()
	{
		HorizontalPanel root = new HorizontalPanel();
		VerticalPanel userInfo = new VerticalPanel();
		userInfo.setHeight("500px");
		userInfo.setStyleName(ColConCSS.ITEM_PANEL.getStyle());
		userInfo.setVerticalAlignment(HasVerticalAlignment.ALIGN_TOP);
		userInfo.add(buildUserInfo());
		
		VerticalPanel userNews = new VerticalPanel();
		userNews.setHeight("500px");
		userNews.setVerticalAlignment(HasVerticalAlignment.ALIGN_TOP);
		userNews.setStyleName(ColConCSS.ITEM_PANEL.getStyle());
		userNews.add(buildUserNews());
		
		VerticalPanel userGroups = new VerticalPanel();
		userGroups.setStyleName(ColConCSS.ITEM_PANEL.getStyle());
		userGroups.setHeight("500px");
		userGroups.setVerticalAlignment(HasVerticalAlignment.ALIGN_TOP);
		userGroups.add(buildUserGroups());
		root.add(userInfo);
		root.add(userNews);
		root.add(userGroups);
		
		return root;
	}
	private Widget buildUserNews()
	{
		VerticalPanel news = new VerticalPanel();
		Label header = new Label("News");
		news.setWidth("400px");
		header.setStyleName(ColConCSS.PAGE_TITLE.getStyle());
		news.add(header);
		news.add(((AppWidgets)getClient().widgets()).buildHR());
		news.add(new NewsList(getClient(), getItem().getPath()));
		return news;
	}
	private Widget buildUserGroups()
	{
		VerticalPanel groups = new VerticalPanel();
		groups.setWidth("400px");
		Label header = new Label("Titles");
		header.setStyleName(ColConCSS.PAGE_TITLE.getStyle());
		groups.add(header);
		groups.add(((AppWidgets)getClient().widgets()).buildHR());
		return groups;
	}
	public Widget buildUserInfo(){
		VerticalPanel userContent = new VerticalPanel();
		
		String email = getItem().getArg(Arg.EMAIL);
		String username = getItem().getArg(Arg.ID);
		String joinedDate = getItem().getCreationTime();
		String visibility = getItem().getArg(Arg.PUBLIC);
		boolean visible = true;
		if(email != null){
			Image gravatar = new Image(ImageUtil.getGravatar(email, "mm", 200));
			gravatar.setStyleName(ColConCSS.GRAVATAR_200.getStyle());
			userContent.add(gravatar);
		}
		if(username != null){
			Label user = new Label(username);
			user.setStyleName(ColConCSS.PAGE_TITLE.getStyle());
			userContent.add(user);
		}
		userContent.add(((AppWidgets)getClient().widgets()).buildHR());
		if(visibility != null){
			HorizontalPanel panel = new HorizontalPanel();
			Image icon = new Image();
			icon.setUrlAndVisibleRect("img/icons.png", 20, 0, 20, 20);
			icon.setStyleName(ColConCSS.ICON.getStyle());
			Label address;
			if(visibility.equals("true")){
				address = new Label("Public");
				visible = true;
			}
			else{
				address = new Label("Private");
				visible = false;
			}
			panel.add(icon);
			panel.add(address);
			userContent.add(panel);
		}
		if(visible && email != null){
			HorizontalPanel panel = new HorizontalPanel();
			Image icon = new Image();
			icon.setUrlAndVisibleRect("img/icons.png", 140, 0, 20, 20);
			icon.setStyleName(ColConCSS.ICON.getStyle());
			Label address = new Label(email);
			panel.add(icon);
			panel.add(address);
			userContent.add(panel);
		}
		if(visible && (joinedDate != null || joinedDate != "")){
			HorizontalPanel panel = new HorizontalPanel();
			Image icon = new Image();
			icon.setUrlAndVisibleRect("img/icons.png", 40, 0, 20, 20);
			icon.setStyleName(ColConCSS.ICON.getStyle());
			Label address = new Label("Joined " + TimeUtil.getDifference(new Date(Long.parseLong(joinedDate)), new Date()));
			panel.add(icon);
			panel.add(address);
			userContent.add(panel);
		}
		if(visible){
			HorizontalPanel panel = new HorizontalPanel();
			Image icon = new Image();
			icon.setUrlAndVisibleRect("img/icons.png", 60, 0, 20, 20);
			icon.setStyleName(ColConCSS.ICON.getStyle());
			Label address = new Label("Member of " + "21" /*get vote count*/ + " groups");
			panel.add(icon);
			panel.add(address);
			userContent.add(panel);
		}
		if(visible){
			HorizontalPanel panel = new HorizontalPanel();
			Image icon = new Image();
			icon.setUrlAndVisibleRect("img/icons.png", 80, 0, 20, 20);
			icon.setStyleName(ColConCSS.ICON.getStyle());
			Label address = new Label("Voted " + "21" /*get vote count*/ + " times");
			panel.add(icon);
			panel.add(address);
			userContent.add(panel);
		}
		userContent.add(((AppWidgets)getClient().widgets()).buildHR());
		return userContent;
	}
}
