/**
 * 
 */
package org.colcon.web.client.ui;

import org.colcon.burocrat.api.client.IClient;
import org.colcon.burocrat.api.model.IResponse;
import org.colcon.burocrat.client.CSS;
import org.colcon.burocrat.client.ui.HeaderPanel;
import org.colcon.web.client.AppPageImpl;

import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Hyperlink;

/**
 * @author Jesse Freitas
 *
 */
public class AppHeaderPanel extends HeaderPanel
{

	/**
	 * @param client
	 */
	public AppHeaderPanel(IClient client)
	{
		super(client);
	}
	public void init(IResponse data) 
	{
		HorizontalPanel panel = new HorizontalPanel();
		panel.setWidth("100%");
	
		panel.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_LEFT);
		panel.setStyleName(CSS.HEADER.getStyle());
		
//		HorizontalPanel links = new HorizontalPanel();
//		
//		for(PageImpl path : PageImpl.values())
//		{
//			String token = path.name().toLowerCase();
//			Hyperlink link = new Hyperlink("<p class=\"" + CSS.HEADER_TEXT.getStyle() + "\">" + token + "</p>", true, token);
//			
//			if(path == PageImpl.HOME)
//			{
//				continue;
//			}
//			
//			String currentPath = getClient().getPath();
//			if((currentPath == null || currentPath.isEmpty()) && path.equals(PageImpl.HOME) || currentPath.equalsIgnoreCase(token))
//				link.addStyleName(CSS.HEADER_TEXT_SELECTED.getStyle());
//			
//			links.add(link);
//		}
		
		HorizontalPanel left = new HorizontalPanel();
		
		Hyperlink home = new Hyperlink("", true, AppPageImpl.HOME.name().toLowerCase());
		home.setWidth("93px");
		home.setHeight("30px");
		home.addStyleName(CSS.LOGO.getStyle());
		
		left.add(home);
		HorizontalPanel notifications = new HorizontalPanel();
		if(getClient().isLoggedIn()){
			notifications.add(new NotificationPanel(getClient()));
			notifications.add(new NavPanel(getClient()));
		}
		left.add(notifications);
		///left.add(links);
		
		panel.add(left);
		
		panel.setHorizontalAlignment(HorizontalPanel.ALIGN_RIGHT);
		
		HorizontalPanel right = new HorizontalPanel();
		
		right.add(new UserLoginPanel(getClient()));
		
		panel.add(right);
		
		add(panel);
	}
}
