package org.colcon.web.client.ui;

import org.colcon.burocrat.api.client.IClient;
import org.colcon.burocrat.api.model.IResponse;
import org.colcon.burocrat.client.ui.BurocratPanel;
import org.colcon.burocrat.client.utils.ImageUtil;
import org.colcon.burocrat.model.Arg;
import org.colcon.web.client.ColConCSS;

import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.VerticalPanel;

public class LoggedInPanel extends BurocratPanel implements ClickHandler
{
	private Label settings = new Label("Settings");
	private Label profile = new Label("Profile");
	private Label logout = new Label("Log Out");
	private Label refresh = new Label("Refresh");
	
	public LoggedInPanel(IClient client)
	{
		super(client);
	}
	public void init(IResponse data)
	{
		HorizontalPanel root = new HorizontalPanel();
		String email = "";
		email = getClient().getUser().getArg(Arg.EMAIL);
		HTML gravatar;
		if(email != null)
			gravatar = new HTML("<img src=\"" + ImageUtil.getGravatar(email, "mm", 100) + "\">");
		else
			gravatar = new HTML("<img src=\"" + ImageUtil.getGravatar("collective_congress", "mm", 100) + "\">");
		gravatar.setStyleName(ColConCSS.GRAVATAR_100.getStyle());
		root.add(gravatar);
		VerticalPanel info = new VerticalPanel();
		refresh.setStyleName(ColConCSS.PAGE_SUBTITLE_LINK.getStyle());
		settings.setStyleName(ColConCSS.PAGE_SUBTITLE_LINK.getStyle());
		profile.setStyleName(ColConCSS.PAGE_SUBTITLE_LINK.getStyle());
		logout.setStyleName(ColConCSS.PAGE_SUBTITLE_LINK.getStyle());
		logout.setWordWrap(false);
		logout.addClickHandler(this);
		refresh.addClickHandler(this);
		info.add(profile);
		info.add(settings);
		info.add(refresh);
		info.add(logout);
		root.add(info);
		add(root);
	}
	public static void main(String[] args)
	{
		// TODO Auto-generated method stub

	}
	public void onClick(ClickEvent event)
	{
		if(event.getSource().equals(logout)){
			getClient().logout();
			getClient().show("home");
			getClient().refresh();
		}
		if(event.getSource().equals(refresh)){
			getClient().refresh();
		}
	}
}
