/**
 * 
 */
package org.colcon.web.client.ui;

import org.colcon.burocrat.api.client.IClient;
import org.colcon.burocrat.api.model.IResponse;
import org.colcon.burocrat.client.ui.BurocratPanel;
import org.colcon.web.client.ColConCSS;

import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.FocusEvent;
import com.google.gwt.event.dom.client.FocusHandler;
import com.google.gwt.event.dom.client.KeyCodes;
import com.google.gwt.event.dom.client.KeyPressEvent;
import com.google.gwt.event.dom.client.KeyPressHandler;
import com.google.gwt.user.client.Event;
import com.google.gwt.user.client.ui.TextBox;

/**
 * @author Dan Vegeto;
 * Modified by Jesse Freitas
 */
public class NavPanel extends BurocratPanel implements KeyPressHandler, ClickHandler, FocusHandler
{

	private TextBox bar;

	/**
	 * @param client
	 */
	public NavPanel(IClient client)
	{
		super(client);
	}

	/**
	 * @see org.colcon.burocrat.client.ui.BurocratPanel#init(org.colcon.burocrat.api.model.IResponse)
	 */
	@Override
	public void init(IResponse data)
	{
		clear();
		setWidth("100%");
		bar = new TextBox();
		bar.setStyleName(ColConCSS.TEXTBOX_HEADER.getStyle());
		bar.addFocusHandler(this);
		sinkEvents(Event.ONKEYPRESS);
		addHandler(this, KeyPressEvent.getType());
		addHandler(this, ClickEvent.getType());
		add(bar);	
	}

	@Override
	public void onClick(ClickEvent event)
	{
		if(bar.getText() == "search...")
			bar.setText("");
		else {
			bar.selectAll();
		}
	}

	@Override
	public void onKeyPress(KeyPressEvent event)
	{
		if(event.getNativeEvent().getKeyCode() == KeyCodes.KEY_ENTER)
		{
			String text = bar.getText();

			if(text != null && !text.isEmpty())
				getClient().show(text);
		}
	}

	@Override
	public void onFocus(FocusEvent event)
	{
		bar.selectAll();
	}
}
