/**
 * 
 */
package org.colcon.web.client.ui;

import org.colcon.burocrat.api.client.IClient;
import org.colcon.burocrat.api.model.IResponse;
import org.colcon.burocrat.client.CSS;
import org.colcon.burocrat.client.ui.BurocratPanel;
import org.colcon.burocrat.client.utils.ImageUtil;
import org.colcon.burocrat.model.Arg;
import org.colcon.web.client.ColConCSS;

import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.logical.shared.CloseEvent;
import com.google.gwt.event.logical.shared.CloseHandler;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.PopupPanel;

/**
 * @author Jesse
 * 
 */
public class UserLoginPanel extends BurocratPanel implements ClickHandler,
		CloseHandler<PopupPanel>
{
	HTML userIcon;
	boolean expanded = false;
	PopupPanel panel;
	private Label username;

	/**
	 * @param client
	 */
	public UserLoginPanel(IClient client)
	{
		super(client);
	}

	/**
	 * @see org.colcon.burocrat.client.ui.BurocratPanel#init(org.colcon.burocrat.api.model.IResponse)
	 */
	@Override
	public void init(IResponse data)
	{
		HorizontalPanel main = new HorizontalPanel();
		main.setVerticalAlignment(HorizontalPanel.ALIGN_MIDDLE);
		userIcon = new HTML("<img src=\""
				+ ImageUtil.getGravatar("collective_congress", "blank", 42)
				+ "\">");
		if (getClient().isLoggedIn())
		{
			username = new Label(getClient().getUserId());
			username.setStyleName(CSS.HEADER_TEXT.getStyle());
			username.addClickHandler(this);
			main.add(username);
			String email = "";
			if(getClient().getUser() != null){
				email = getClient().getUser().getArg(Arg.EMAIL);
			}
			if(email != null){
				userIcon = new HTML("<img src=\""
					+ ImageUtil.getGravatar(email, "blank", 40) + "\">");
			}
		}
		userIcon.setStyleName(ColConCSS.USER_ICON.getStyle());
		main.add(userIcon);
		userIcon.addClickHandler(this);
		add(main);
	}

	public void onClick(ClickEvent event)
	{
		if (event.getSource().equals(userIcon))
		{
			if (panel != null)
				panel.hide();
			panel = buildPopup(event);
			panel.addCloseHandler(this);
			userIcon.removeStyleName(ColConCSS.USER_ICON_SELECTED.getStyle());
			if (event.getSource() == userIcon && !expanded)
			{
				userIcon.addStyleName(ColConCSS.USER_ICON_SELECTED.getStyle());
				panel.setPopupPosition(userIcon.getAbsoluteLeft(),
						userIcon.getAbsoluteTop() + userIcon.getOffsetHeight());
				expanded = true;
				panel.showRelativeTo(userIcon);
				return;
			}
			expanded = false;
		}
		if (event.getSource().equals(username))
		{
			getClient().show("users/" + getClient().getUserId());
		}
	}

	private PopupPanel buildPopup(ClickEvent event)
	{
		PopupPanel panel = new PopupPanel(true);
		panel.setStyleName(ColConCSS.NOTE_POPUP.getStyle());
		panel.add(new UserHeaderPanel(getClient()));
		return panel;
	}

	@Override
	public void onClose(CloseEvent<PopupPanel> event)
	{
		userIcon.removeStyleName(ColConCSS.USER_ICON_SELECTED.getStyle());
	}

}
