package org.colcon.web.model;

import org.colcon.burocrat.api.model.IItem;
import org.colcon.burocrat.api.model.IModel;
import org.colcon.burocrat.api.utils.ArrayUtil;
import org.colcon.burocrat.model.Arg;
import org.colcon.burocrat.model.Cmd;
import org.colcon.burocrat.model.Constants;
import org.colcon.burocrat.model.Item;
import org.colcon.burocrat.model.ItemType;
import org.colcon.burocrat.model.Model;
import org.colcon.burocrat.model.Parser;

public class AppModel
{
	public static final String version = "0.1.0";
	
	public static IModel instance =
			
		new Model
		(
			ArrayUtil.append(Arg.getValues(), AppArg.getValues()), 
			ArrayUtil.append(Cmd.getValues(), AppCmd.getValues()),
			ArrayUtil.append(ItemType.getValues(), AppItemType.getValues()),
			
			new Parser(), 
			
			new IItem[]
			{
				// server metadata
				new Item(
						Arg.TYPE.put(ItemType.METADATA), 
						Arg.VERSION.put(version)),
				
				// top-level containers
				new Item(
						Arg.TYPE.put(ItemType.CONTAINER),
						Arg.ID.put(ItemType.LINK.plural())),
					
				new Item(
						Arg.TYPE.put(ItemType.CONTAINER),
						Arg.ID.put(ItemType.NEWS.plural())),
						
				new Item(
						Arg.TYPE.put(ItemType.CONTAINER),
						Arg.ID.put(ItemType.USER.plural())),
						
				new Item(
						Arg.TYPE.put(ItemType.CONTAINER),
						Arg.ID.put(AppItemType.GROUP.plural())),
						
				new Item(
						Arg.TYPE.put(ItemType.CONTAINER),
						Arg.ID.put(AppItemType.VOTE.plural())),
						
				// predefined users
				new Item(
						Arg.TYPE.put(ItemType.USER),
						Arg.ID.put(Constants.ADMIN),
						Arg.PASSWORD.put(Constants.ADMIN_PASSWORD),
						Arg.EMAIL.put(Constants.ADMIN_EMAIL),
						Arg.EMAIL_CONFIRMED.put(Boolean.valueOf(true))),
					
				new Item(
						Arg.TYPE.put(ItemType.USER),
						Arg.ID.put(Constants.GUEST),
						Arg.PASSWORD.put(Constants.GUEST_PASSWORD),
						Arg.EMAIL.put(Constants.GUEST_EMAIL),
						Arg.EMAIL_CONFIRMED.put(Boolean.valueOf(true)))
			}
		);
}
