package org.colcon.web.server;

import org.colcon.burocrat.api.model.ICommand;
import org.colcon.burocrat.api.server.IAuthenticator;
import org.colcon.burocrat.api.server.IServer;
import org.colcon.burocrat.api.utils.ArrayUtil;
import org.colcon.burocrat.server.ArgImpl;
import org.colcon.burocrat.server.CmdImpl;
import org.colcon.burocrat.server.Database;
import org.colcon.burocrat.server.Emailer;
import org.colcon.burocrat.server.Encryptor;
import org.colcon.burocrat.server.ItemTypeImpl;
import org.colcon.burocrat.server.Notifier;
import org.colcon.burocrat.server.Server;

public class AppServer 
{
	public static IServer instance = new Server
	(
		ArrayUtil.append(ArgImpl.getValues(), AppArgImpl.getValues()),
		ArrayUtil.append(CmdImpl.getValues(), AppCmdImpl.getValues()), 
		ArrayUtil.append(ItemTypeImpl.values(), AppItemTypeImpl.getValues()),
		
		new Database(), 
		
		// AUTHENTICATION DISABLED
		// replace with 'new Authenticator()' to enable
		new IAuthenticator()
		{	
			public boolean authenticate(String id, String password) {return true;}
			public boolean hasPermission(String agent, ICommand command) {return true;}
		},
		
		new Encryptor(), 
		
		new Emailer("[colcon]", "colcongress@collectivecongress.appspotmail.com", 
				"<p>This email was sent automatically by <a href=\"collectivecongress.com\">collectivecongress.com</a></p>" +
				"<p>Please email us at <a href=\"mailto:colcongress@gmail.com\">colcongress@gmail.com</a></p>"
		), 
		
		new Notifier()
	);
}
