package org.colcon.burocrat.api.server;

import java.util.Map;

import org.colcon.burocrat.api.model.IArg;
import org.colcon.burocrat.api.model.ICommand;
import org.colcon.burocrat.api.model.IItem;
import org.colcon.burocrat.api.model.IResponse;

public interface IServer 
{
	public void				init();
	
	public IDatabase		database();
	public IAuthenticator	authenticator();
	public IEncryptor		encryptor();
	public IEmailer			emailer();
	public INotifier		notifier();
	
	public IArgImpl[]		getArgImpls();
	public ICmdImpl[]		getCmdImpls();
	public IItemTypeImpl[]	getItemTypeImpls();
	
	public IArgImpl			getArgImpl(String name);
	public ICmdImpl			getCmdImpl(String name);
	public IItemTypeImpl	getItemTypeImpl(String name);
	
	public IResponse		validate(String agent, ICommand command);
	public IResponse		execute	(String agent, ICommand command);
	
	public IItem			get		(String path);
	public void				post	(IItem 	item);
	public void				put		(IItem 	item);
	public void				delete	(String path);
	
	public IItem[]			query	(String parent, int limit, int offset, IArg sort, boolean ascending, Map<IArg, String> filters);
}
