package org.colcon.burocrat.api.utils;

import java.util.LinkedList;
import java.util.List;

import org.colcon.burocrat.api.client.IItemPageImpl;
import org.colcon.burocrat.api.client.IPageImpl;
import org.colcon.burocrat.api.model.IArg;
import org.colcon.burocrat.api.model.ICmd;
import org.colcon.burocrat.api.model.IItemType;
import org.colcon.burocrat.api.server.IArgImpl;
import org.colcon.burocrat.api.server.ICmdImpl;
import org.colcon.burocrat.api.server.IItemTypeImpl;

public class ArrayUtil 
{
	public static <T> T[] append(T[] array0, T[] array1)
	{
		if(array0 == null || array1 == null)
			return null;
		
		List<T> list = new LinkedList<T>();
		
		for(T t : array0)
			list.add(t);
		
		for(T t : array1)
			list.add(t);
		
		return list.toArray(array0);
	}
	
	public static IArg[] append(IArg[] array0, IArg[] array1)
	{
		if(array0 == null || array1 == null)
			return null;
		
		List<IArg> list = new LinkedList<IArg>();
		
		for(IArg t : array0)
			list.add(t);
		
		for(IArg t : array1)
			list.add(t);
		
		return list.toArray(new IArg[0]);
	}
	
	public static ICmd[] append(ICmd[] array0, ICmd[] array1)
	{
		if(array0 == null || array1 == null)
			return null;
		
		List<ICmd> list = new LinkedList<ICmd>();
		
		for(ICmd t : array0)
			list.add(t);
		
		for(ICmd t : array1)
			list.add(t);
		
		return list.toArray(new ICmd[0]);
	}
	
	public static IItemType[] append(IItemType[] array0, IItemType[] array1)
	{
		if(array0 == null || array1 == null)
			return null;
		
		List<IItemType> list = new LinkedList<IItemType>();
		
		for(IItemType t : array0)
			list.add(t);
		
		for(IItemType t : array1)
			list.add(t);
		
		return list.toArray(new IItemType[0]);
	}
	
	public static IArgImpl[] append(IArgImpl[] array0, IArgImpl[] array1)
	{
		if(array0 == null || array1 == null)
			return null;
		
		List<IArgImpl> list = new LinkedList<IArgImpl>();
		
		for(IArgImpl t : array0)
			list.add(t);
		
		for(IArgImpl t : array1)
			list.add(t);
		
		return list.toArray(new IArgImpl[0]);
	}
	
	public static ICmdImpl[] append(ICmdImpl[] array0, ICmdImpl[] array1)
	{
		if(array0 == null || array1 == null)
			return null;
		
		List<ICmdImpl> list = new LinkedList<ICmdImpl>();
		
		for(ICmdImpl t : array0)
			list.add(t);
		
		for(ICmdImpl t : array1)
			list.add(t);
		
		return list.toArray(new ICmdImpl[0]);
	}
	
	public static IPageImpl[] append(IPageImpl[] array0, IPageImpl[] array1)
	{
		if(array0 == null || array1 == null)
			return null;
		
		List<IPageImpl> list = new LinkedList<IPageImpl>();
		
		for(IPageImpl t : array0)
			list.add(t);
		
		for(IPageImpl t : array1)
			list.add(t);
		
		return list.toArray(new IPageImpl[0]);
	}
	
	public static IItemPageImpl[] append(IItemPageImpl[] array0, IItemPageImpl[] array1)
	{
		if(array0 == null || array1 == null)
			return null;
		
		List<IItemPageImpl> list = new LinkedList<IItemPageImpl>();
		
		for(IItemPageImpl t : array0)
			list.add(t);
		
		for(IItemPageImpl t : array1)
			list.add(t);
		
		return list.toArray(new IItemPageImpl[0]);
	}
	
	public static boolean[] append(boolean[] array0, boolean[] array1)
	{
		if(array0 == null || array1 == null)
			return null;
		
		boolean[] array2 = new boolean[array0.length + array1.length];
		
		for(int i = 0; i < array0.length; i++)
			array2[i] = array0[i];
		
		for(int i = 0; i < array1.length; i++)
			array2[i + array0.length] = array1[i];
		
		return array2;
	}
	
	public static IItemTypeImpl[] append(IItemTypeImpl[] array0, IItemTypeImpl[] array1)
	{
		if(array0 == null || array1 == null)
			return null;
		
		List<IItemTypeImpl> list = new LinkedList<IItemTypeImpl>();
		
		for(IItemTypeImpl t : array0)
			list.add(t);
		
		for(IItemTypeImpl t : array1)
			list.add(t);
		
		return list.toArray(new IItemTypeImpl[0]);
	}
	
	public static <T> T[] subArray(T[] array, int start, int end)
	{
		if(array == null)
			return null;
		
		List<T> list = new LinkedList<T>();
		
		for(int i = start; i < end && i < array.length; i++)
			list.add(array[i]);
		
		return list.toArray(array);
	}
}
