package org.colcon.burocrat.api.utils;

import java.util.Map;

import org.colcon.burocrat.api.model.IEnum;

/**
 * This class is for common operations
 * that deal with enums.
 * 
 * @author Dan Vegeto
 *
 */
public class EnumUtil 
{
	public static <T extends IEnum> T getValue(T[] array, String name)
	{
		for(T t : array)
			if(t.name().equalsIgnoreCase(name))
				return t;
		
		return null;
	}
	
	public static <T extends IEnum> void putAll(Map<String, T> map, T[] array)
	{
		for(T t : array)
			map.put(t.name().toUpperCase(), t);
	}
}
