package org.colcon.burocrat.client;

import org.colcon.burocrat.api.client.IClient;
import org.colcon.burocrat.api.client.IPageImpl;
import org.colcon.burocrat.client.pages.FormPage;
import org.colcon.burocrat.client.pages.HomePage;
import org.colcon.burocrat.client.pages.NewsPage;
import org.colcon.burocrat.client.pages.TerminalPage;
import org.colcon.burocrat.client.ui.BurocratPage;

/**
 * 
 * These are implementations of static pages within the site, each with a URL of <pre>domain/#page</pre>
 * 
 * @author Dan Vegeto
 *
 */
public enum PageImpl implements IPageImpl
{
	HOME
	{
		public BurocratPage buildPage(IClient client) 
		{
			return new HomePage(client);
		}
	},
	
	NEWS
	{
		public BurocratPage buildPage(IClient client) 
		{
			return new NewsPage(client);
		}
	},
	
	FORM
	{
		public BurocratPage buildPage(IClient client) 
		{
			return new FormPage(client);
		}
	},
	
	TERMINAL
	{
		public BurocratPage buildPage(IClient client) 
		{
			return new TerminalPage(client);
		}
	}
	
	;
	
	public static IPageImpl[] getValues()
	{
		return (IPageImpl[])values();
	}
}
