package org.colcon.burocrat.client.form;

import org.colcon.burocrat.api.client.IClient;
import org.colcon.burocrat.api.model.IArg;
import org.colcon.burocrat.api.model.IResponse;
import org.colcon.burocrat.client.BurocratField;
import org.colcon.burocrat.client.CSS;

import com.google.gwt.user.client.ui.PasswordTextBox;

/**
 * 
 * A BurocratField for entering passwords
 * 
 * @author Dan Vegeto
 *
 */
public class PasswordBoxField extends BurocratField 
{
	private PasswordTextBox passwordBox;
	
	public PasswordBoxField(IClient client, IArg arg) 
	{
		super(client, arg);
	}

	public void init(IResponse data) 
	{
		passwordBox = new PasswordTextBox();
		passwordBox.setStyleName(CSS.TEXT.getStyle());;
		
		if(getChangeHandler() != null)
			passwordBox.addChangeHandler(getChangeHandler());
		
		add(passwordBox);
	}
	
	public String getValue() 
	{
		return passwordBox.getText();
	}

	public void setValue(String value) 
	{
		passwordBox.setText(value);
	}
}
