package org.colcon.burocrat.client.pages;

import org.colcon.burocrat.api.client.IClient;
import org.colcon.burocrat.api.model.IResponse;
import org.colcon.burocrat.client.list.NewsList;
import org.colcon.burocrat.client.ui.BurocratPage;
import org.colcon.burocrat.model.ItemType;

/**
 * 
 * This is the top-level news feed for the entire site, consisting of 
 * a NewsList for all public news items
 * 
 * @author Dan Vegeto
 *
 */
public class NewsPage extends BurocratPage 
{
	public NewsPage(IClient client) 
	{
		super(client);	
	}

	public void init(IResponse data)
	{
		super.init(data);
		
		NewsList list = new NewsList(getClient(), ItemType.NEWS.plural());
		
		add(list);
	}
}
