package org.colcon.burocrat.client.ui;

import org.colcon.burocrat.api.client.IClient;
import org.colcon.burocrat.api.model.ICommand;
import org.colcon.burocrat.api.model.IResponse;

import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.FlowPanel;

/**
 * 
 * The superclass for all panels
 * 
 * @author Dan Vegeto
 *
 */
public abstract class BurocratPanel extends FlowPanel
{	
	private IClient client;
	
	public BurocratPanel(IClient client) 
	{	
		this.client = client;
	}
	
	public IClient getClient()
	{
		return client;
	}
	
	public ICommand getRequest()
	{
		return null;
	}
	
	public void refresh()
	{
		clear();
		onLoad();
	}
	
	protected void onLoad()
	{
		super.onLoad();
		
		if(getRequest() == null)
			init(null);
		else
		{
			add(getClient().widgets().loading());
		
			getClient().sendRequest(getRequest(), new AsyncCallback<IResponse>()
			{
				public void onFailure(Throwable caught) 
				{
					clear();
					add(getClient().widgets().error());
				}
	
				public void onSuccess(IResponse result) 
				{
					clear();
					init(result);
				}
			});
		}
	}
	
	public abstract void init(IResponse data);
}
