package org.colcon.burocrat.client.ui;

import org.colcon.burocrat.api.client.IClient;
import org.colcon.burocrat.api.model.IResponse;
import org.colcon.burocrat.client.CSS;
import org.colcon.burocrat.client.PageImpl;

import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Hyperlink;

/**
 * 
 * The header at the top of every page, which includes a logo,
 * links to various subpages, and user account controls
 * 
 * @author Dan Vegeto
 *
 */
public class HeaderPanel extends BurocratPanel 
{
	public HeaderPanel(IClient client) 
	{
		super(client);
	}
	
	public void init(IResponse data) 
	{
		HorizontalPanel panel = new HorizontalPanel();
		panel.setWidth("100%");
		
		panel.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_LEFT);
		panel.setStyleName(CSS.HEADER.getStyle());
		
		HorizontalPanel links = new HorizontalPanel();
		
		for(PageImpl path : PageImpl.values())
		{
			String token = path.name().toLowerCase();
			Hyperlink link = new Hyperlink("<p class=\"" + CSS.HEADER_TEXT.getStyle() + "\">" + token + "</p>", true, token);
			
			if(path == PageImpl.HOME)
			{
				link.setHTML("<img src=\"img/logo.png\"/>");
				link.addStyleName(CSS.LOGO.getStyle());
			}
			
			String currentPath = getClient().getPath();
			if((currentPath == null || currentPath.isEmpty()) && path.equals(PageImpl.HOME) || currentPath.equalsIgnoreCase(token))
				link.addStyleName(CSS.HEADER_TEXT_SELECTED.getStyle());
			
			links.add(link);
		}
		
		panel.add(links);
		
		panel.add(new UserHeaderPanel(getClient()));
		
		add(panel);
	}
}
