package org.colcon.burocrat.client.ui;

import org.colcon.burocrat.api.client.IClient;
import org.colcon.burocrat.api.model.IResponse;
import org.colcon.burocrat.client.CSS;
import org.colcon.burocrat.model.ItemType;
import org.colcon.burocrat.model.Model;

import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Hyperlink;

/**
 * 
 * This is shown in the header when the user is logged in
 * 
 * @author Dan Vegeto
 *
 */
public class LoggedInPanel extends BurocratPanel implements ClickHandler
{
	private Button logout;
	
	public LoggedInPanel(IClient client) 
	{
		super(client);
	}

	public void init(IResponse data) 
	{
		HorizontalPanel panel = new HorizontalPanel();
		panel.setWidth("100%");
		panel.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_RIGHT);
		
		HorizontalPanel rightPanel = new HorizontalPanel();
		rightPanel.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_RIGHT);
		
		logout = new Button("logout");
		logout.setStyleName(CSS.USER_PANEL_BUTTON.getStyle());
		logout.addClickHandler(this);
		
		String id = getClient().getUserId();
		
		// path = "users/" + id
		String path = Model.instance.parser().composePath(ItemType.USER.plural(), id);
		
		Hyperlink userLink = new Hyperlink("<p class=\"" + CSS.HEADER_TEXT.getStyle() + "\">" + id + "</p>", true, path);
		userLink.setStyleName(CSS.USER_PANEL_TEXT.getStyle());
		
		rightPanel.add(userLink);
		rightPanel.add(logout);
		
		panel.add(rightPanel);
		add(panel);
	}

	public void onClick(ClickEvent event) 
	{
		if(event.getSource().equals(logout))
		{
			getClient().logout();
			getClient().refresh();
		}
	}
}
