package org.colcon.burocrat.model;

import java.util.Map;

import org.colcon.burocrat.api.model.IArg;
import org.colcon.burocrat.api.model.IArgValue;
import org.colcon.burocrat.api.model.ICmd;
import org.colcon.burocrat.api.model.ICommand;

/**
 * 
 * This is a map representation of a server request, which is 
 * sent from the client to the server along with an async callback
 * 
 * @author Dan Vegeto
 *
 */
public class Command extends ArgObject implements ICommand
{
	public Command(IArgValue... values)
	{
		super(values);
	}
	
	public Command(Map<IArg, String> map)
	{
		super(map);
	}
	
	public ICmd getCmd()
	{
		String cmd = getArg(Arg.CMD);
		
		if(cmd == null)
			return null;
		
		return Model.instance.getCmd(cmd);
	}
}
