package org.colcon.burocrat.model;

import java.util.Map;

import org.colcon.burocrat.api.model.IArg;
import org.colcon.burocrat.api.model.IArgValue;
import org.colcon.burocrat.api.model.ILink;
import org.colcon.burocrat.api.utils.URLUtil;

/**
 * 
 * This is a representation of a hyperlink that includes a history token, 
 * which may contain a number of key-value pairs
 * 
 * @author Dan Vegeto
 *
 */
public class Link extends ArgObject implements ILink 
{
	private String path;
	
	public Link(String path, Map<IArg, String> args)
	{
		super(args);
		
		this.path = path;
	}
	
	public Link(String path, IArgValue... args)
	{
		super(args);
		
		this.path = path;
	}
	
	public String getPath()
	{
		return path;
	}
	
	public String toString()
	{
		return Model.instance.parser().composeLink(this);
	}
	
	public String toURLString(String url)
	{
		return url + "/#" + URLUtil.encode(toString());
	}
}
