package org.colcon.burocrat.server;

import javax.servlet.ServletException;

import org.colcon.burocrat.api.model.ICommand;
import org.colcon.burocrat.client.BurocratService;
import org.colcon.burocrat.model.CmdFlag;
import org.colcon.burocrat.model.ItemType;
import org.colcon.burocrat.model.Model;
import org.colcon.burocrat.model.Response;

import com.google.gwt.user.server.rpc.RemoteServiceServlet;

/**
 * The server side implementation of the RPC service.
 */
@SuppressWarnings("serial")
public class BurocratServiceImpl extends RemoteServiceServlet implements BurocratService 
{
	public void init() throws ServletException
	{
		super.init();
		
		Server.instance.init();
	}
	
	public String sendRequest(String id, String password, String command)
	{
		ICommand commandObj = Model.instance.parser().parseCommand(command);
		
		boolean authentic = Server.instance.authenticator().authenticate(id, password);
		
		if(!commandObj.getCmd().hasFlag(CmdFlag.OPEN) && !authentic)
			return new Response(false, "invalid id or password").toString();
		
		String agent = ItemType.USER.getInstancePath(id);
		
		boolean permission = Server.instance.authenticator().hasPermission(agent, commandObj);
		
		if(!permission)
			return new Response(false, "agent '" + agent + "' lacks the necessary permission").toString();
		
		String result = Server.instance.execute(agent, commandObj).toString();
		
		return result;
	}
}
